module prop_mod

  implicit none

  integer, private                                     :: nt, n1, n2

  contains

  subroutine prop_init(n1_in, n2_in, nt_in)
    integer                        :: n1_in, n2_in, nt_in
    n1 = n1_in
    n2 = n2_in
    nt = nt_in
  end subroutine

  function prop_op(adj, add, model, data) result(stat)
    logical,intent(in) :: adj, add
    real,dimension(:)  :: model, data
    integer            :: stat
    call prop_op2(adj, add, model, data)
    stat=0
  end function

  subroutine prop_op2(adj, add, model, data)
    logical,intent(in)        :: adj, add 
    real, dimension(n1,n2,nt) :: model, data
    if(adj) then
      if(.not. add) model = 0.
      call c_prop_adj(data, model)
    else
      if(.not. add) data = 0.
      call c_prop(model, data)
    end if
  end subroutine

end module
