program Himage

  use sep

  implicit none

  integer                              :: n1, n2
  real                                 :: o1, d1, o2, d2, vmin, vmax
  real, dimension(:,:), allocatable    :: vel

  call sep_init()

  call from_history("n1", n1)
  call from_history("o1", o1)
  call from_history("d1", d1)
  call from_history("n2", n2)
  call from_history("o2", o2)
  call from_history("d2", d2)

  call from_param("vmin", vmin)
  call from_param("vmax", vmax)

  allocate(vel(n1,n2))
  vel = 0.

!  call random_number(vel)
!  vel = vel*(vmax-vmin) + vmin
  vel = (vmin+vmax)/2.

  vel(n1/5+1:n1*2/5,1:n2/3) = vmin
  vel(n1/5+1:n1*2/5,n2/3+1:n2) = vmax

  vel(n1*2/5+1:n1*3/5,1:n2*2/3) = vmax
  vel(n1*2/5+1:n1*3/5,n2*2/3+1:n2) = vmin

  vel(n1*3/5+1:n1*4/5,1:n2/3) = vmin
  vel(n1*3/5+1:n1*4/5,n2/3+1:n2) = vmax

  call to_history("n1", n1)
  call to_history("o1", o1)
  call to_history("d1", d1)
  call to_history("n2", n2)
  call to_history("o2", o2)
  call to_history("d2", d2)

  call sep_write(vel)

  call sep_close()
end program
